var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';

import createComponent from '../../utils/createComponent';

var Form = forwardRef(function (props, ref) {
  return React.createElement('form', _extends({
    ref: ref
  }, props, {
    onSubmit: function onSubmit(e) {
      e.preventDefault();
      props.onSubmit(e);
    }
  }));
});

Form.displayName = 'Form';

Form.propTypes = {
  onSubmit: PropTypes.func
};

Form.defaultProps = {
  onSubmit: function onSubmit() {}
};

Form.Group = createComponent('Form.Group', 'form-group');

Form.Text = createComponent('Form.Text', 'form-text');

// eslint-disable-next-line
var Label = forwardRef(function (props, ref) {
  return React.createElement('label', _extends({ ref: ref }, props));
});
Label.displayName = 'Form.Label';

Form.Label = Label;

export default Form;