var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import buttonColors from '../../utils/buttonColors';
import sizes from '../../utils/sizes';

import './File.css';

var File = forwardRef(function (_ref, ref) {
  var id = _ref.id,
      color = _ref.color,
      outline = _ref.outline,
      size = _ref.size,
      disabled = _ref.disabled,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['id', 'color', 'outline', 'size', 'disabled', 'className', 'style', 'children']);

  return React.createElement(
    'label',
    {
      htmlFor: id,
      className: cn('btn', 'btn-file', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { disabled: disabled }, className),
      style: style
    },
    children,
    React.createElement('input', _extends({ ref: ref }, props, { id: id, type: 'file', disabled: disabled }))
  );
});

File.displayName = 'Input.File';

File.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  color: PropTypes.oneOf(buttonColors),
  disabled: PropTypes.bool,
  id: PropTypes.string.isRequired,
  outline: PropTypes.bool,
  size: PropTypes.oneOf(sizes),
  style: PropTypes.object // eslint-disable-line react/forbid-prop-types
};

File.defaultProps = {
  children: null,
  className: undefined,
  color: 'primary',
  disabled: false,
  outline: false,
  size: 'md',
  style: {}
};

export default File;