var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import createComponent from '../../utils/createComponent';
import sizes from '../../utils/sizes';

import File from './File';

var unstyledInputTypes = ['button', 'checkbox', 'file', 'hidden', 'image', 'radio', 'reset', 'submit', 'range'];

var Input = forwardRef(function (_ref, ref) {
  var size = _ref.size,
      props = _objectWithoutProperties(_ref, ['size']);

  var className = !unstyledInputTypes.includes(props.type) ? cn(props.readOnly ? 'form-control-plaintext' : 'form-control', 'form-control-' + size, props.className) : '';
  return React.createElement('input', _extends({ ref: ref }, props, className ? { className: className } : {}));
});

Input.displayName = 'Input';

Input.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  readOnly: PropTypes.bool,
  size: PropTypes.oneOf(sizes),
  type: PropTypes.string
} : {};

Input.defaultProps = {
  className: undefined,
  readOnly: undefined,
  size: 'md',
  type: 'text'
};

Input.File = File;

Input.Group = createComponent('Input.Group', 'input-group');

Input.GroupPrepend = createComponent('Input.GroupPrepend', 'input-group-prepend');

Input.GroupAppend = createComponent('Input.GroupAppend', 'input-group-append');

Input.GroupText = createComponent('Input.GroupText', 'input-group-text');

export default Input;