import React, { cloneElement } from 'react';
import PropTypes from 'prop-types';

import { Consumer } from './context';

var Reference = function Reference(_ref) {
  var element = _ref.children;
  return React.createElement(
    Consumer,
    null,
    function (_ref2) {
      var setReferenceNode = _ref2.setReferenceNode,
          onMouseEnter = _ref2.onMouseEnter,
          onMouseLeave = _ref2.onMouseLeave;
      return cloneElement(element, {
        ref: setReferenceNode,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      });
    }
  );
};

Reference.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.element.isRequired
} : {};

export default Reference;