var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import Icon from '../Icon';

import iconSizes from '../../utils/iconSizes';

import './index.css';

var Spinner = function Spinner(_ref) {
  var size = _ref.size,
      inline = _ref.inline,
      className = _ref.className,
      iconName = _ref.iconName,
      props = _objectWithoutProperties(_ref, ['size', 'inline', 'className', 'iconName']);

  return React.createElement(
    'span',
    _extends({}, props, { className: cn({ 'spinner-on-full-height': !inline }, className) }),
    React.createElement(Icon, { name: iconName, size: size, pulse: true })
  );
};

Spinner.propTypes = process.env.NODE_ENV !== "production" ? {
  size: PropTypes.oneOf(iconSizes),
  inline: PropTypes.bool,
  className: PropTypes.string,
  iconName: PropTypes.string
} : {};

Spinner.defaultProps = {
  size: '3x',
  inline: false,
  className: '',
  iconName: 'spinner'
};

export default Spinner;