var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

var NavItem = function NavItem(_ref) {
  var title = _ref.title,
      active = _ref.active,
      className = _ref.className,
      _onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['title', 'active', 'className', 'onClick']);

  return React.createElement(
    'li',
    _extends({}, props, { className: cn('nav-item', className) }),
    React.createElement(
      'a',
      {
        href: '#',
        className: cn('nav-link', { active: active }),
        onClick: function onClick(e) {
          e.preventDefault();
          _onClick(e);
        }
      },
      title
    )
  );
};

NavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  active: PropTypes.bool,
  className: PropTypes.string,
  onClick: PropTypes.func
} : {};

NavItem.defaultProps = {
  title: '',
  active: false,
  className: '',
  onClick: function onClick() {}
};

export default NavItem;