function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import PopperJS from 'popper.js';

var Popper = function (_Component) {
  _inherits(Popper, _Component);

  function Popper() {
    var _temp, _this, _ret;

    _classCallCheck(this, Popper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      placement: _this.props.placement
    }, _this.popper = null, _this.popperNode = null, _this.arrowNode = null, _this.initPopper = function () {
      _this.popper = new PopperJS(_this.props.reference, _this.popperNode, {
        placement: _this.props.placement,
        modifiers: {
          arrow: {
            element: _this.arrowNode
          },
          updateState: {
            enabled: true,
            order: 900,
            fn: function fn(data) {
              if (data.placement !== _this.state.placement) {
                _this.setState({ placement: data.placement });
              }
              return data;
            }
          }
        }
      });
    }, _this.updatePopper = function () {
      if (_this.popper) {
        _this.popper.update();
      }
    }, _this.destroyPopper = function () {
      if (_this.popper) {
        _this.popper.destroy();
      }
    }, _this.setPopperNode = function (node) {
      _this.popperNode = node;
    }, _this.setArrowNode = function (node) {
      _this.arrowNode = node;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Popper.prototype.componentDidMount = function componentDidMount() {
    this.initPopper();
  };

  Popper.prototype.componentDidUpdate = function componentDidUpdate() {
    this.updatePopper();
  };

  Popper.prototype.componentWillUnmount = function componentWillUnmount() {
    this.destroyPopper();
  };

  Popper.prototype.render = function render() {
    var children = this.props.children;
    var placement = this.state.placement;


    return React.createElement(
      'div',
      {
        ref: this.setPopperNode,
        className: 'tooltip bs-tooltip-' + placement + ' show',
        role: 'tooltip'
      },
      React.createElement('div', { ref: this.setArrowNode, className: 'arrow' }),
      React.createElement(
        'div',
        { className: 'tooltip-inner' },
        children
      )
    );
  };

  return Popper;
}(Component);

Popper.propTypes = process.env.NODE_ENV !== "production" ? {
  placement: PropTypes.oneOf(['top', 'left', 'bottom', 'right']).isRequired,
  reference: PropTypes.instanceOf(Element).isRequired,
  children: PropTypes.node.isRequired
} : {};


export default Popper;