var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

var createComponent = function createComponent(displayName, className) {
  var Component = forwardRef(function (_ref, ref) {
    var Tag = _ref.tag,
        props = _objectWithoutProperties(_ref, ['tag']);

    return React.createElement(Tag, _extends({ ref: ref }, props, { className: cn(className, props.className) }));
  });

  Component.displayName = displayName;

  Component.propTypes = {
    className: PropTypes.string,
    tag: PropTypes.oneOfType([PropTypes.elementType, PropTypes.func, PropTypes.string])
  };

  Component.defaultProps = {
    className: undefined,
    tag: 'div'
  };

  return Component;
};

export default createComponent;