'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _colors = require('../../utils/colors');

var _colors2 = _interopRequireDefault(_colors);

var _createComponent = require('../../utils/createComponent');

var _createComponent2 = _interopRequireDefault(_createComponent);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = (0, _createComponent2.default)('Card.Container', 'card');
var Header = (0, _createComponent2.default)('Card.Header', 'card-header');
var HeaderInner = (0, _createComponent2.default)('Card.HeaderInner', 'card-header-inner');
var HeaderTitle = (0, _createComponent2.default)('Card.HeaderTitle', 'card-header-title');
var Body = (0, _createComponent2.default)('Card.Body', 'card-body');
var Footer = (0, _createComponent2.default)('Card.Footer', 'card-footer');

var Card = (_temp2 = _class = function (_Component) {
  _inherits(Card, _Component);

  function Card() {
    var _temp, _this, _ret;

    _classCallCheck(this, Card);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      showBodyAndFooter: true
    }, _this.toggleBodyAndFooter = function () {
      return _this.setState(function (state) {
        return {
          showBodyAndFooter: !state.showBodyAndFooter
        };
      }, _this.props.onToggle);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Card.prototype.render = function render() {
    var _cn;

    var _props = this.props,
        color = _props.color,
        title = _props.title,
        controls = _props.controls,
        collapsible = _props.collapsible,
        closed = _props.closed,
        customBody = _props.customBody,
        footer = _props.footer,
        fullHeight = _props.fullHeight,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['color', 'title', 'controls', 'collapsible', 'closed', 'customBody', 'footer', 'fullHeight', 'children']);

    var showBodyAndFooter = closed === null ? this.state.showBodyAndFooter : !closed;
    var containerClassName = (0, _classnames2.default)((_cn = {
      'card-on-full-height': fullHeight
    }, _cn['bg-' + color] = color, _cn['text-white'] = color && color !== 'light' && color !== 'warning', _cn), props.className);
    var bodyClassName = (0, _classnames2.default)({
      'd-none': !showBodyAndFooter,
      'card-body-on-full-height': fullHeight,
      'rounded-top': fullHeight && !(title || controls),
      'rounded-bottom': fullHeight && !footer
    });
    var footerClassName = (0, _classnames2.default)({ 'd-none': !showBodyAndFooter });

    return _react2.default.createElement(
      Container,
      _extends({}, props, { className: containerClassName }),
      title || controls ? _react2.default.createElement(
        Card.Header,
        null,
        _react2.default.createElement(
          HeaderInner,
          null,
          typeof title === 'string' ? _react2.default.createElement(
            HeaderTitle,
            null,
            title
          ) : title,
          typeof controls === 'string' ? _react2.default.createElement(
            'div',
            null,
            controls
          ) : controls,
          collapsible && !fullHeight ? _react2.default.createElement(
            _Button2.default,
            {
              color: color || 'light',
              className: 'card-toggle',
              onClick: this.toggleBodyAndFooter
            },
            _react2.default.createElement(_Icon2.default, { name: 'chevron-' + (showBodyAndFooter ? 'down' : 'up') })
          ) : null
        )
      ) : null,
      customBody ? _react2.default.createElement(
        'div',
        { className: bodyClassName },
        children
      ) : _react2.default.createElement(
        Card.Body,
        { className: bodyClassName },
        children
      ),
      footer ? _react2.default.createElement(
        Card.Footer,
        { className: footerClassName },
        footer
      ) : null
    );
  };

  return Card;
}(_react.Component), _class.defaultProps = {
  color: undefined,
  title: null,
  controls: null,
  collapsible: true,
  closed: null,
  onToggle: function onToggle() {},
  customBody: false,
  footer: null,
  fullHeight: false,
  children: null
}, _class.Container = Container, _class.Header = Header, _class.HeaderInner = HeaderInner, _class.HeaderTitle = HeaderTitle, _class.Body = Body, _class.Footer = Footer, _temp2);
Card.propTypes = process.env.NODE_ENV !== "production" ? {
  color: _propTypes2.default.oneOf(_colors2.default),
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  controls: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  collapsible: _propTypes2.default.bool,
  closed: _propTypes2.default.oneOf([true, false, null]),
  onToggle: _propTypes2.default.func,
  customBody: _propTypes2.default.bool,
  footer: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  fullHeight: _propTypes2.default.bool,
  children: _propTypes2.default.node
} : {};
exports.default = Card;
module.exports = exports['default'];