'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createComponent = require('../../utils/createComponent');

var _createComponent2 = _interopRequireDefault(_createComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Form = (0, _react.forwardRef)(function (props, ref) {
  return _react2.default.createElement('form', _extends({
    ref: ref
  }, props, {
    onSubmit: function onSubmit(e) {
      e.preventDefault();
      props.onSubmit(e);
    }
  }));
});

Form.displayName = 'Form';

Form.propTypes = {
  onSubmit: _propTypes2.default.func
};

Form.defaultProps = {
  onSubmit: function onSubmit() {}
};

Form.Group = (0, _createComponent2.default)('Form.Group', 'form-group');

Form.Text = (0, _createComponent2.default)('Form.Text', 'form-text');

// eslint-disable-next-line
var Label = (0, _react.forwardRef)(function (props, ref) {
  return _react2.default.createElement('label', _extends({ ref: ref }, props));
});
Label.displayName = 'Form.Label';

Form.Label = Label;

exports.default = Form;
module.exports = exports['default'];