'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _createComponent = require('../../utils/createComponent');

var _createComponent2 = _interopRequireDefault(_createComponent);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

var _File = require('./File');

var _File2 = _interopRequireDefault(_File);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var unstyledInputTypes = ['button', 'checkbox', 'file', 'hidden', 'image', 'radio', 'reset', 'submit', 'range'];

var Input = (0, _react.forwardRef)(function (_ref, ref) {
  var size = _ref.size,
      props = _objectWithoutProperties(_ref, ['size']);

  var className = !unstyledInputTypes.includes(props.type) ? (0, _classnames2.default)(props.readOnly ? 'form-control-plaintext' : 'form-control', 'form-control-' + size, props.className) : '';
  return _react2.default.createElement('input', _extends({ ref: ref }, props, className ? { className: className } : {}));
});

Input.displayName = 'Input';

Input.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  readOnly: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(_sizes2.default),
  type: _propTypes2.default.string
} : {};

Input.defaultProps = {
  className: undefined,
  readOnly: undefined,
  size: 'md',
  type: 'text'
};

Input.File = _File2.default;

Input.Group = (0, _createComponent2.default)('Input.Group', 'input-group');

Input.GroupPrepend = (0, _createComponent2.default)('Input.GroupPrepend', 'input-group-prepend');

Input.GroupAppend = (0, _createComponent2.default)('Input.GroupAppend', 'input-group-append');

Input.GroupText = (0, _createComponent2.default)('Input.GroupText', 'input-group-text');

exports.default = Input;
module.exports = exports['default'];