'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _colors = require('../../utils/colors');

var _colors2 = _interopRequireDefault(_colors);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Item = (0, _react.forwardRef)(function (_ref, ref) {
  var _cn;

  var Tag = _ref.tag,
      color = _ref.color,
      active = _ref.active,
      clickable = _ref.clickable,
      disabled = _ref.disabled,
      onClick = _ref.onClick,
      onToggle = _ref.onToggle,
      toggleIconName = _ref.toggleIconName,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['tag', 'color', 'active', 'clickable', 'disabled', 'onClick', 'onToggle', 'toggleIconName', 'children']);

  return _react2.default.createElement(
    Tag,
    _extends({
      ref: ref
    }, typeof onClick === 'function' ? { role: 'presentation', onClick: onClick } : {}, props, {
      className: (0, _classnames2.default)('list-group-item', (_cn = {}, _cn['list-group-item-' + color] = color, _cn['list-group-item-action'] = typeof onClick === 'function' || clickable, _cn.toggled = typeof onToggle === 'function', _cn.active = active, _cn.disabled = disabled, _cn), props.className)
    }),
    typeof onToggle === 'function' ? _react2.default.createElement(
      _Button2.default,
      {
        color: active ? 'primary' : 'link',
        disabled: disabled,
        className: 'list-group-item-toggle',
        onClick: onToggle
      },
      _react2.default.createElement(_Icon2.default, { name: toggleIconName })
    ) : null,
    children
  );
});

Item.displayName = 'List.Item';

Item.propTypes = {
  active: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  clickable: _propTypes2.default.bool,
  color: _propTypes2.default.oneOf(_colors2.default),
  disabled: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onToggle: _propTypes2.default.func,
  tag: _propTypes2.default.oneOfType([_propTypes2.default.elementType, _propTypes2.default.func, _propTypes2.default.string]),
  toggleIconName: _propTypes2.default.string
};

Item.defaultProps = {
  active: false,
  children: null,
  className: undefined,
  clickable: false,
  color: undefined,
  disabled: false,
  onClick: null,
  onToggle: null,
  tag: 'li',
  toggleIconName: 'plus'
};

exports.default = Item;
module.exports = exports['default'];