'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var NavItem = function NavItem(_ref) {
  var title = _ref.title,
      active = _ref.active,
      className = _ref.className,
      _onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['title', 'active', 'className', 'onClick']);

  return _react2.default.createElement(
    'li',
    _extends({}, props, { className: (0, _classnames2.default)('nav-item', className) }),
    _react2.default.createElement(
      'a',
      {
        href: '#',
        className: (0, _classnames2.default)('nav-link', { active: active }),
        onClick: function onClick(e) {
          e.preventDefault();
          _onClick(e);
        }
      },
      title
    )
  );
};

NavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  active: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func
} : {};

NavItem.defaultProps = {
  title: '',
  active: false,
  className: '',
  onClick: function onClick() {}
};

exports.default = NavItem;
module.exports = exports['default'];