'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Nav = require('./Nav');

var _Nav2 = _interopRequireDefault(_Nav);

var _NavItem = require('./NavItem');

var _NavItem2 = _interopRequireDefault(_NavItem);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = (_temp2 = _class = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs() {
    var _temp, _this, _ret;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      selectedIndex: _this.props.defaultIndex
    }, _this.onToggle = function (selectedIndex) {
      return _this.setState({
        selectedIndex: selectedIndex
      }, function () {
        return _this.props.onToggle(selectedIndex);
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Tabs.prototype.render = function render() {
    var _this2 = this;

    var children = this.props.children;
    var selectedIndex = this.state.selectedIndex;


    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _Nav2.default,
        null,
        _react.Children.map(children, function (_ref, index) {
          var title = _ref.props.title;
          return _react2.default.createElement(_NavItem2.default, {
            key: index,
            title: title,
            active: selectedIndex === index,
            onClick: function onClick() {
              return _this2.onToggle(index);
            }
          });
        })
      ),
      _react.Children.map(children, function (item, index) {
        return (0, _react.cloneElement)(item, { key: index, active: selectedIndex === index });
      })
    );
  };

  return Tabs;
}(_react.Component), _class.defaultProps = {
  defaultIndex: 0,
  onToggle: function onToggle() {},
  children: null
}, _class.Nav = _Nav2.default, _class.NavItem = _NavItem2.default, _class.Item = _Item2.default, _temp2);
Tabs.propTypes = process.env.NODE_ENV !== "production" ? {
  defaultIndex: _propTypes2.default.number,
  onToggle: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};
exports.default = Tabs;
module.exports = exports['default'];